freeslot(
	"MT_HUBSPOT",

	"MT_LEVELSPOT",
	"S_LEVELSPOT",
	"SPR_LVLA",
	"SPR_LVLB",
	"SPR_LVLC",

	"MT_LEVELPORTAL",
	"S_LEVELPORTAL1",
	"S_LEVELPORTAL2",
	"S_LEVELPORTAL3",

	"S_BOSSPORTAL1",
	"S_BOSSPORTAL2",
	"S_BOSSPORTAL3",

	"S_DISABLEDPORTAL1",
	"S_DISABLEDPORTAL2",
	"S_DISABLEDPORTAL3",

	"MT_LEVELLIGHT",
	"S_LEVELLIGHT1",
	"S_LEVELLIGHT2",
	"SPR_MAPP",

	"MT_WATERFALLDROPSPAWNER",
	"MT_WATERFALLDROP",
	"S_WATERFALLDROP",
	"S_WATERFALLDROPSPLISH1",
	"S_WATERFALLDROPSPLISH2",
	"S_WATERFALLDROPSPLISH3",
	"S_WATERFALLDROPSPLISH4",
	"S_WATERFALLDROPSPLISH5",
	"S_WATERFALLDROPSPLISH6",
	"S_WATERFALLDROPSPLISH7",
	"S_WATERFALLDROPSPLISH8",
	"S_WATERFALLDROPSPLISH9",
	"SPR_WFDP",

	"MT_LEVELSPARKLE",
	"S_LEVELSPARKLE1",
	"S_LEVELSPARKLE2",
	"S_LEVELSPARKLE3",
	"S_LEVELSPARKLE4",
	"S_BOSSSPARKLE1",
	"S_BOSSSPARKLE2",
	"S_BOSSSPARKLE3",
	"S_BOSSSPARKLE4",
	"SPR_HSPK"
)

mobjinfo[MT_HUBSPOT] = {
	--$Name Hub Thinker Spot
	--$Sprite MAPPD0
	doomednum = 3500,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_LEVELSPOT] = {
	--$Name Level Portal
	--$Sprite LVLAA0
	doomednum = 3501,
	spawnstate = S_LEVELSPOT,
	spawnhealth = 1000,
	radius = 48*FRACUNIT,
	height = 96*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

states[S_LEVELSPOT] = {SPR_LVLA, FF_FULLBRIGHT|FF_TRANS20, -1, nil, 0, 0, S_LEVELSPOT}

mobjinfo[MT_LEVELPORTAL] = {
	spawnstate = S_LEVELPORTAL1,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 12*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOTHINK
}

states[S_LEVELPORTAL1] = {SPR_MAPP, FF_FULLBRIGHT, 3, nil, 0, 0, S_LEVELPORTAL2}
states[S_LEVELPORTAL2] = {SPR_MAPP, FF_FULLBRIGHT|1, 3, nil, 0, 0, S_LEVELPORTAL3}
states[S_LEVELPORTAL3] = {SPR_MAPP, FF_FULLBRIGHT|2, 3, nil, 0, 0, S_LEVELPORTAL1}

states[S_BOSSPORTAL1] = {SPR_MAPP, FF_FULLBRIGHT|3, 3, nil, 0, 0, S_BOSSPORTAL2}
states[S_BOSSPORTAL2] = {SPR_MAPP, FF_FULLBRIGHT|4, 3, nil, 0, 0, S_BOSSPORTAL3}
states[S_BOSSPORTAL3] = {SPR_MAPP, FF_FULLBRIGHT|5, 3, nil, 0, 0, S_BOSSPORTAL1}

states[S_DISABLEDPORTAL1] = {SPR_MAPP, FF_FULLBRIGHT|6, 3, nil, 0, 0, S_DISABLEDPORTAL2}
states[S_DISABLEDPORTAL2] = {SPR_MAPP, FF_FULLBRIGHT|7, 3, nil, 0, 0, S_DISABLEDPORTAL3}
states[S_DISABLEDPORTAL3] = {SPR_MAPP, FF_FULLBRIGHT|8, 3, nil, 0, 0, S_DISABLEDPORTAL1}

mobjinfo[MT_LEVELLIGHT] = {
	spawnstate = S_LEVELLIGHT1,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY
}

states[S_LEVELLIGHT1] = {SPR_MAPP, FF_FULLBRIGHT|FF_TRANS80|9, 1, nil, 0, 0, S_LEVELLIGHT2}
states[S_LEVELLIGHT2] = {SPR_MAPP, FF_FULLBRIGHT|FF_TRANS90|9, 1, nil, 0, 0, S_LEVELLIGHT1}

mobjinfo[MT_WATERFALLDROPSPAWNER] = {
	--$Name Waterfall Spot
	--$Sprite SPLHB0
	doomednum = 3502,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_WATERFALLDROP] = {
	spawnstate = S_WATERFALLDROP,
	deathstate = S_WATERFALLDROPSPLISH1,
	spawnhealth = 1,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_SCENERY
}

states[S_WATERFALLDROP] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80, -1, nil, 0, 0, S_NULL}
states[S_WATERFALLDROPSPLISH1] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|1, 2, nil, 0, 0, S_WATERFALLDROPSPLISH2}
states[S_WATERFALLDROPSPLISH2] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|2, 2, nil, 0, 0, S_WATERFALLDROPSPLISH3}
states[S_WATERFALLDROPSPLISH3] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|3, 2, nil, 0, 0, S_WATERFALLDROPSPLISH4}
states[S_WATERFALLDROPSPLISH4] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|4, 2, nil, 0, 0, S_WATERFALLDROPSPLISH5}
states[S_WATERFALLDROPSPLISH5] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|5, 2, nil, 0, 0, S_WATERFALLDROPSPLISH6}
states[S_WATERFALLDROPSPLISH6] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|6, 2, nil, 0, 0, S_WATERFALLDROPSPLISH7}
states[S_WATERFALLDROPSPLISH7] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|7, 2, nil, 0, 0, S_WATERFALLDROPSPLISH8}
states[S_WATERFALLDROPSPLISH8] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|8, 2, nil, 0, 0, S_WATERFALLDROPSPLISH9}
states[S_WATERFALLDROPSPLISH9] = {SPR_WFDP, FF_FULLBRIGHT|FF_TRANS80|9, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_LEVELSPARKLE] = {
	spawnstate = S_LEVELSPARKLE1,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY
}

states[S_LEVELSPARKLE1] = {SPR_HSPK, FF_FULLBRIGHT, 3, nil, 0, 0, S_LEVELSPARKLE2}
states[S_LEVELSPARKLE2] = {SPR_HSPK, FF_FULLBRIGHT|1, 3, nil, 0, 0, S_LEVELSPARKLE3}
states[S_LEVELSPARKLE3] = {SPR_HSPK, FF_FULLBRIGHT|2, 3, nil, 0, 0, S_LEVELSPARKLE4}
states[S_LEVELSPARKLE4] = {SPR_HSPK, FF_FULLBRIGHT, 3, nil, 0, 0, S_NULL}

states[S_BOSSSPARKLE1] = {SPR_HSPK, FF_FULLBRIGHT|3, 3, nil, 0, 0, S_BOSSSPARKLE2}
states[S_BOSSSPARKLE2] = {SPR_HSPK, FF_FULLBRIGHT|4, 3, nil, 0, 0, S_BOSSSPARKLE3}
states[S_BOSSSPARKLE3] = {SPR_HSPK, FF_FULLBRIGHT|5, 3, nil, 0, 0, S_BOSSSPARKLE4}
states[S_BOSSSPARKLE4] = {SPR_HSPK, FF_FULLBRIGHT|3, 3, nil, 0, 0, S_NULL}

local oldchub = 748
local firstmap = 749 //S1

local defaultMap = oldchub
local failedString = "Vote failed!"
--local passedString = "Vote passed!"

local usingterminal = rawget(_G, "terminal")
local usingcustomhud = rawget(_G, "customhud")
local usingio = rawget(_G, "io")

local ambushflags2 = false -- since plusc added papersprites
if (_G["MF2_AMBUSH"])
	ambushflags2 = true
end

local clientplayer
local clientrenderer = "none"

local mapChecks = {}
local playerVotes = {}
--local bannedVoters = {}
local failedlevel = false
local exitingcheck = false
local pausetimer = false
local didmodifiedprint = false
local nolives = false

local hubSpot
local lasthub = oldchub

local currentCecho = {
	text = nil,
	flags = 0,
	timer = 0
}

local currentVoteInfo = {
	voting = false,
	timer = 0,
	map = defaultMap,
	player = nil,
	unlockreset = false
}

local cv_vote
local cv_pick
local cv_nolives

local function returnToHub(player, str)
	if (str and str:lower() == "yes")
		sugoi.ExitLevel(oldchub, 1)
	else
		CONS_Printf(player, "Type \"abortlevel yes\" to quit the current entry, and return to the contest hub.")
	end
end
COM_AddCommand("abortlevel", returnToHub, COM_ADMIN)

local function returnSpecialCVarValue(cvar)
	if (cvar == "nolives")
		if (modeattacking) or (not G_GametypeUsesLives())
			return 0
		else
			return cv_nolives.value
		end
	end
end

local function resetLives()
	if (returnSpecialCVarValue("nolives")) 
		sugoi.DEShortcut("lives", false)
		nolives = true
		return 
	end
	if not (G_GametypeUsesLives()) return end
	if (modeattacking) return end
	if (marathonmode) return end
	
	nolives = false
	sugoi.DEShortcut("lives", true)
	for player in players.iterate
		if (player.bot) continue end
		player.lives = 5 -- yes cheaty
	end
end

cv_vote = CV_RegisterVar({
	name = "oldc_votetime",
	defaultvalue = "10",
	flags = CV_SAVE|CV_NETVAR,
	PossibleValue = {MIN = -1, MAX = 3600}
})

cv_pick = CV_RegisterVar({
	name = "oldc_whopicks",
	defaultvalue = "All",
	flags = CV_SAVE|CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = {All = 0, Host = 1}
})

cv_nolives = CV_RegisterVar({
	name = "oldc_nolives",
	defaultvalue = "Off",
	flags = CV_CALL|CV_NETVAR|CV_NOINIT|CV_SHOWMODIF, -- CV_CHEAT?
	PossibleValue = CV_OnOff,
	func = resetLives
})


-- SUGOI global stuff:
-- sugoi.GameName() returns "kimokawaiii", and 3. For mod support.
-- sugoi.FailLevel() causes the level to be considered "failed", which prevents awarding emblems or setting the map cleared status. Exiting the level itself should still handled by the script itself.
-- sugoi.PauseTimer() prevents both player time and Marathon Mode time from increasing
-- sugoi.IsHubLevel() returns true if a hub spot was found, false otherwise.
-- sugoi.GetClient() returns the player that the hud is rendered for (dubbed the "client", for the best approximation of client-sided effects)
-- sugoi.ExitLevel(level, skipstats) is a replacement for G_ExitLevel. This version prevents the level from restarting twice.
-- sugoi.DoCecho(text, flags, timer) prints a cecho-like prompt, similar to the look of SRB2's unlock cechos.

rawset(_G, "sugoi", {})
function sugoi.GameName() return "OLDC",1 end

function sugoi.ShouldShowHUD()
	if (currentVoteInfo.voting and hubSpot)
		return false
	end
	
	return true
end

function sugoi.FailLevel() failedlevel = true end
function sugoi.PauseTimer() pausetimer = true end
function sugoi.IsHubLevel() if (hubSpot) return true else return false end end
function sugoi.GetClient() return clientplayer end

function sugoi.ExitLevel(v1, v2)
	if (exitingcheck)
		return
	end

	if (v2 != nil)
		G_SetCustomExitVars(v1, v2)
		G_ExitLevel()
	else
		G_SetCustomExitVars(v1)
		G_ExitLevel()
	end

	exitingcheck = true
end

local function tol(gt)
	if (gt == GT_COOP)
		if (multiplayer or netgame)
			return TOL_COOP
		else
			return TOL_SP
		end
	elseif (gt == GT_COMPETITION)
		return TOL_COMPETITION
	elseif (gt == GT_RACE)
		return TOL_RACE
	elseif (gt == GT_MATCH or gt == GT_TEAMMATCH)
		return TOL_MATCH
	elseif (gt == GT_TAG or gt == GT_HIDEANDSEEK)
		return TOL_TAG
	elseif (gt == GT_CTF)
		return TOL_CTF
	end
end

function sugoi.NextLevel(map)
	local nextlevel = defaultMap
	local marathonnext = mapheaderinfo[map].marathonnext
	nextlevel = mapheaderinfo[map].nextlevel

	if (modeattacking) then
		return nextlevel
	end
	
	if (marathonmode) then
		return marathonnext
	end

	if (gametype == GT_COOP)
		nextlevel = oldchub
	elseif (mapheaderinfo[nextlevel])
		-- Find next level of multiplayer gametype
		local n = nextlevel
		local t = tol(gametype)
		local type = mapheaderinfo[n].typeoflevel
		local l = 0

		while not (type & t)
			if (l > 9)
				break
			end

			n = $1+1
			if not (mapheaderinfo[n])
				n = 1 -- Go back to map01
			end

			type = mapheaderinfo[n].typeoflevel
			l = $1+1
		end

		if (type & t)
			nextlevel = n
		end
	end

	return nextlevel
end

function sugoi.GiveEmblem(player)
	if not (failedlevel)
		if (mapheaderinfo[gamemap].countmap)
			if (splitscreen) and not (mapChecks[gamemap])
				if (player and player.valid)
					player.ssnumbeaten = $1+1
				else
					for p in players.iterate
						p.ssnumbeaten = $1+1
					end
				end
			end

			mapChecks[gamemap] = true
		end

		if not (multiplayer or modifiedgame)
		and ((players[0] and players[0].valid) and (players[0].mo and players[0].mo.valid))
			for emblem in mobjs.iterate()
				if (emblem and emblem.valid)
				and (emblem.type == MT_EMBLEM)
				and (emblem.frame == W and emblem.color == SKINCOLOR_GOLD)
					P_TeleportMove(emblem, players[0].mo.x, players[0].mo.y, players[0].mo.z)
				end
			end
		end
	end
end

function sugoi.DEShortcut(item, enable)
	if (item == "lives" and nolives) then
		hud.disable("lives")
		return
	end
	if (enable)
		if (usingcustomhud)
			customhud.enable(item)
		else
			hud.enable(item)
		end
	else
		if (usingcustomhud)
			customhud.disable(item)
		else
			hud.disable(item)
		end
	end
end

function sugoi.DoCecho(text, flags, timer)
	if not (text) return end
	currentCecho.text = text
	
	if (flags)
		currentCecho.flags = flags
	else
		currentCecho.flags = 0
	end
	
	if (timer)
		currentCecho.timer = timer
	else
		currentCecho.timer = 6*TICRATE
	end
end

local function findPlayerFromName(n)
	if not type(n) == "string" return end
	for player in players.iterate
		if player.name == n return player end
	end
end

local function returnHost()
	if (admin)
		return admin
	else
		return server
	end
end

local function getVoteCount(votetype)
	local yes = 0
	local no = 0
	local total = 0
	
	for k,v in pairs(playerVotes)
		if v == true
			yes = $1 + 1
			total = $1 + 1
		elseif v == false
			no = $1 + 1
			total = $1 + 1
		end
	end
	
	if (votetype == "yes" or votetype == true)
		return yes
	elseif (votetype == "no" or votetype == false)
		return no
	else
		return total
	end
end

local function getPlayerCount(bots,spect,nobvote)
	local playercount = 0
	
	for player in players.iterate
		if ((player.bot) and not (bots)) continue end
		if ((player.spectator) and not (spect)) continue end
		--if ((bannedVoters[#player]) and (nobvote)) continue end
		playercount = $1 + 1
	end
	
	return playercount
end

local function sign(num)
	if (num < 0)
		return -1
	else
		return 1
	end
end

local function levelHUDdisables(m)
	if (mapheaderinfo[m].hidetitle)
		sugoi.DEShortcut("stagetitle", false)
	else
		sugoi.DEShortcut("stagetitle", true)
	end

	if (mapheaderinfo[m].creditsmap
	or mapheaderinfo[m].marathonstartup)
		sugoi.DEShortcut("score", false)
		sugoi.DEShortcut("time", false)
		sugoi.DEShortcut("rings", false)
		sugoi.DEShortcut("lives", false)
	else
		sugoi.DEShortcut("score", true)
		sugoi.DEShortcut("time", true)
		sugoi.DEShortcut("rings", true)
		sugoi.DEShortcut("lives", true)
	end
end

local function failVote(cecho)
	if not (cecho)
		cecho = failedString
	end
	
	sugoi.DoCecho(cecho, V_YELLOWMAP|V_RETURN8, 6*TICRATE)
			
	if (currentVoteInfo.player and currentVoteInfo.player.valid)
		if (multiplayer) -- KIMOKAWAIII has level portals instead, so you don't get caught in the voting sector
			if (hubSpot and hubSpot.valid)
				P_TeleportMove(currentVoteInfo.player.mo, hubSpot.x, hubSpot.y, hubSpot.z)
				currentVoteInfo.player.mo.angle = hubSpot.angle
			else
				G_DoReborn(#(currentVoteInfo.player))
			end

			S_StartSound(currentVoteInfo.player.mo, sfx_mixup, currentVoteInfo.player)
			--P_FlashPal(currentVoteInfo.player, 1, 5)
		end
	end
end

local function finishVote(naturalend)
	if not currentVoteInfo.voting return end
	
	if (naturalend and G_PlatformGametype())
		if ((getVoteCount("yes") > getVoteCount("no")) or (cv_vote.value == -1))
			sugoi.ExitLevel(currentVoteInfo.map, 1)
		else
			failVote()
		end
	end
	
	playerVotes = {}
	currentVoteInfo.voting = false
	currentVoteInfo.timer = 0
	currentVoteInfo.map = defaultMap
	currentVoteInfo.player = nil
	levelHUDdisables(gamemap)
end

local function hubLevelThinker(mo)
	if not G_PlatformGametype() return end
	
	if not (hubSpot)
		hubSpot = mo
	end
	
	if not (currentVoteInfo.voting) return end
	
	if (currentVoteInfo.timer > 0 and cv_vote.value > 0) or (cv_vote.value == 0) 
		for player in players.iterate
			player.pflags = $1|PF_FULLSTASIS
				
			local buffertime = 2
			if cv_vote.value > 0
				buffertime = (cv_vote.value * TICRATE) - 10
			end
				
			if (currentVoteInfo.timer >= buffertime and player.cmd.buttons)
				player.disablevote = true
			elseif (player.disablevote) and not (player.cmd.buttons)
				player.disablevote = false
			end
			
			--if (playerVotes[#player] == nil) and not (player.disablevote)
			if not (player.disablevote)
			--and not (player.bot or player.spectating or bannedVoters[#player])
			and not (player.bot or player.spectating)
				if (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_USE)
					playerVotes[#player] = true
				elseif (player.cmd.buttons & BT_USE) and not (player.cmd.buttons & BT_JUMP)
					playerVotes[#player] = false
				end
			end
		end
	end
	
	if (currentVoteInfo.timer <= 0) or (getVoteCount() >= getPlayerCount(false,false,true))
		finishVote(true)
	elseif (cv_vote.value > 0 and currentVoteInfo.timer > 0) or (cv_vote.value == 0 and currentVoteInfo.timer > 1)
		currentVoteInfo.timer = $1 - 1
	end
end


local function playerUI(player)
	if (nolives) then
		if (player.bot) return end
		player.lives = 127
	end
end

local function startVote(mo, map)
	if not (G_PlatformGametype()) return end
	if (currentVoteInfo.voting) return end
	
	if ((mo and mo.valid) and (mo.player and mo.player.valid))
		local player = mo.player
		
		if (player.bot or player.spectator) return end
		--if (bannedVoters[#player]) return end
		
		if (cv_pick.value)
			if (usingterminal)
				if not (player.servperm & terminal.permissions.GAMEMANAGE)
					CONS_Printf(player, "The host has disallowed players without GAMEMANAGE permission from picking levels.")
					return
				end
			elseif not (player == server or player == admin)
				CONS_Printf(player, "The host has disallowed others from picking levels.")
				return
			end
		end
		
		currentVoteInfo.player = player
	end
	
	if (cv_vote.value > 0)
		currentVoteInfo.timer = cv_vote.value * TICRATE
	elseif (cv_vote.value == 0)
		currentVoteInfo.timer = 12
	end
	
	if (map > 0)
		currentVoteInfo.map = map
	else
		currentVoteInfo.map = defaultMap
	end

	currentVoteInfo.voting = true

	sugoi.DEShortcut("score", false)
	sugoi.DEShortcut("time", false)
	sugoi.DEShortcut("rings", false)
	sugoi.DEShortcut("lives", false)
end

local function levelPortalSpawn(mo)
	local map = AngleFixed(mo.angle) / FRACUNIT

	if not (mapheaderinfo[map + firstmap - 1])
		P_RemoveMobj(mo)
		return
	end

	if (map > 0)
		if (map > 52)
			mo.sprite = SPR_LVLC
		elseif (map > 26)
			mo.sprite = SPR_LVLB
		end
		mo.frame = $|((map-1) % 26)
	end

	if not (mapheaderinfo[map + firstmap - 1].typeoflevel & tol(gametype))
		mo.portaldisable = 1
		mo.flags2 = $1|MF2_SHADOW
	end

	P_SpawnMobj(mo.x, mo.y, mo.z, MT_LEVELLIGHT)
	mo.portalz = mo.z
	mo.z = $ + 64*FRACUNIT
	mo.spawned = true
end

local function levelPortalAnim(mo)
	if not (mo.spawned) -- because mobjspawn hook caused unknown weirdness
		if (leveltime > 2) -- wait for level load linedefs
			levelPortalSpawn(mo)
		end
		return
	end

	if (mo.portalz == nil)
		mo.portalz = mo.floorz
	end

	if (mo.lvlportal == nil)
		mo.lvlportal = {}
	end

	local lvl = (AngleFixed(mo.angle) / FRACUNIT) + firstmap - 1

	local amp = 8
	local speed = 2*TICRATE
	local pi = 22*FRACUNIT/7
	local sine = amp * sin((2*pi*speed) * (leveltime + (lvl^2)))
	mo.z = (mo.portalz+64*FRACUNIT) + sine

	local bossoffset = 0
	if (mo.portaldisable)
		bossoffset = 6
	elseif (mapheaderinfo[lvl] and mapheaderinfo[lvl].sugoiboss)
		bossoffset = 3
	end

	if not (mo.lvlportal[1] and mo.lvlportal[1].valid)
		mo.lvlportal[1] = P_SpawnMobj(mo.x, mo.y, mo.portalz, MT_LEVELPORTAL)
		mo.lvlportal[1].target = mo
	end
	mo.lvlportal[1].state = S_LEVELPORTAL1 + ((leveltime/3) % 3) + bossoffset

	local numlayers = 2 -- 1
	local curlayer = 0
	local numparticles = 3
	local curparticle = 2
	local speed = 20
	local rad = 24

	while (curlayer < numlayers)
		for i = curparticle,curparticle+numparticles
			if not (mo.lvlportal[i] and mo.lvlportal[i].valid)
				mo.lvlportal[i] = P_SpawnMobj(mo.x, mo.y, mo.portalz, MT_LEVELPORTAL)
				mo.lvlportal[i].angle = FixedAngle((360*FRACUNIT/numparticles) * (i-(curparticle-1))) - (ANG15*curlayer)
			else
				A_Custom3DRotate(mo.lvlportal[i], rad, speed<<16)
			end
			mo.lvlportal[i].state = S_LEVELPORTAL1 + (((leveltime/3)+curlayer+1) % 3) + bossoffset
			mo.lvlportal[i].target = mo
			mo.lvlportal[i].z = mo.portalz
		end

		curparticle = curparticle+numparticles+1
		--numparticles = $+2
		--speed = 3*$/2
		rad = $+24
		curlayer = $+1
	end

	if (mo.reactiontime > 0)
		mo.reactiontime = $1-1
	end

	if (leveltime % 3 == 0)
	and not (mapChecks[lvl])
	and not (mo.portaldisable)
		local hdist = P_RandomRange(0,80) * FRACUNIT
		local hang = FixedAngle(P_RandomRange(0,359) * FRACUNIT)
		local vdist = P_RandomRange(0,64) * FRACUNIT
		local vang = FixedAngle(P_RandomRange(-180,180) * FRACUNIT)

		local sparkle = P_SpawnMobj(
			mo.x + FixedMul(FixedMul(hdist, cos(hang)), cos(vang)),
			mo.y + FixedMul(FixedMul(hdist, sin(hang)), cos(vang)),
			mo.z + (64<<FRACBITS) + FixedMul(vdist, sin(vang)),
			MT_LEVELSPARKLE
		)

		sparkle.scale = 2*FRACUNIT
		sparkle.destscale = sparkle.scale

		if (mapheaderinfo[lvl] and mapheaderinfo[lvl].sugoiboss)
			sparkle.state = S_BOSSSPARKLE1
		end
	end
end

local function levelPortalTouch(mo, toucher)
	if (mo.portaldisable)
		if (toucher.player and not mo.reactiontime)
			if (mo.portaldisable == 1)
				local gtstr = "Cooperative" -- too lazy to add the others
				CONS_Printf(toucher.player, "This level does not support "..gtstr.." mode.")
			elseif (mo.portaldisable == 2)
				CONS_Printf(toucher.player, "This level needs to be unlocked.")
			end
		end
		mo.reactiontime = TICRATE
	else
		local lvl = (AngleFixed(mo.angle) / FRACUNIT) + firstmap - 1
		startVote(toucher, lvl)
	end
	return true
end

local function dropletSpawner(mo)
	if (mapheaderinfo[gamemap].creditsmap)
		mo.scale = FRACUNIT/2
	end

	if not (leveltime % 3 == 0) return end
	local spawnoffset = P_RandomRange(-96,96) * mo.scale
	local offx = FixedMul(spawnoffset, cos(mo.angle+ANGLE_90))
	local offy = FixedMul(spawnoffset, sin(mo.angle+ANGLE_90))
	local droplet = P_SpawnMobj(mo.x + offx, mo.y + offy, mo.z+1, MT_WATERFALLDROP)
	P_SetScale(droplet, 4 * mo.scale)
	droplet.destscale = droplet.scale
	P_Thrust(droplet, FixedAngle(P_RandomRange(0,359)<<FRACBITS), (P_RandomRange(1,48)*mo.scale)/8)
	P_SetObjectMomZ(droplet, (P_RandomRange(1,48)*mo.scale)/8, true)
	droplet.movefactor = mo.z
end

local function dropletKiller(mo)
	if not (mo.health) return end
	if (mo.z <= mo.movefactor or P_IsObjectOnGround(mo))
		mo.flags = $|MF_NOGRAVITY
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		mo.health = 0
		mo.state = mo.info.deathstate
	end
end

local function loading(map)
	for thing in mapthings.iterate
		if not ((thing and thing.valid) and (thing.mobj and thing.mobj.valid)) continue end
		if (thing.mobj.type == MT_HUBSPOT)
			hubSpot = thing.mobj
		end
	end
	
	if (hubSpot)
		if not (multiplayer or modifiedgame)
			for i=1,3
				P_LinedefExecute(3000+i)
			end
		end
		lasthub = map
	end

	local serverisplayer = false
	for player in players.iterate	
		player.awayviewmobj = nil -- vanilla doesn't reset these already? wut :V
		player.awayviewtics = 0
		player.awayviewaiming = 0

		if (server == player)
			serverisplayer = true
		end
	end
	
	if (server and server.valid)
		server.isdedicated = (not serverisplayer)
	end

	levelHUDdisables(map)
	
	if (map == oldchub and marathonmode) then
		resetLives()
		if (marathonmode) then
			sugoi.ExitLevel(firstmap, 1)
			return
		end
	end
	
	G_SetCustomExitVars(sugoi.NextLevel(map))
end

local function changing(map)
	hubSpot = nil
	failedlevel = false
	exitingcheck = false

	currentCecho.text = nil
	currentCecho.flags = 0
	currentCecho.timer = 0
	
	finishVote(false)

	levelHUDdisables(map)
end

local function resetPlayer(player)
	if (gamemap ~= oldchub) then return end
	player.pflags = $1 & ~PF_FORCESTRAFE
	local good, valid = pcall(do return p.realmo and p.realmo.valid end)
	if (good and valid) then
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		player.charability = skins[player.mo.skin].ability
		player.charability2 = skins[player.mo.skin].ability2
		player.normalspeed = skins[player.mo.skin].normalspeed
	end	
end

local function globalTimers()
	if ((currentCecho.timer != nil) and (currentCecho.timer > 0))
		currentCecho.timer = $1-1
	end
	
	local allexiting = true
	for player in players.iterate
		if not (player.exiting)
			allexiting = false
		end
	end

	pausetimer = false
end


local function netplaySync(net)
	mapChecks = net(mapChecks)
	playerVotes = net(playerVotes)
	--bannedVoters = net(bannedVoters)
	failedlevel = net(failedlevel)
	exitingcheck = net(exitingcheck)
	pausetimer = net(pausetimer)
	nolives = net(nolives)
	
	hubSpot = net(hubSpot)
	
	currentCecho = net(currentCecho)
	currentVoteInfo = net(currentVoteInfo)
end

addHook("MobjThinker", hubLevelThinker, MT_HUBSPOT)
--addHook("MobjSpawn", levelPortalSpawn, MT_LEVELSPOT)
addHook("MobjThinker", levelPortalAnim, MT_LEVELSPOT)
addHook("TouchSpecial", levelPortalTouch, MT_LEVELSPOT)
addHook("MobjThinker", dropletSpawner, MT_WATERFALLDROPSPAWNER)
addHook("MobjThinker", dropletKiller, MT_WATERFALLDROP)

addHook("PlayerSpawn", resetPlayer)
addHook("PlayerThink", playerUI)

addHook("MapLoad", loading)
addHook("MapChange", changing)
addHook("ThinkFrame", globalTimers)

addHook("NetVars", netplaySync)

local function getMapName(map)
	if not (map)
		if (currentVoteInfo.map)
			map = currentVoteInfo.map
		else
			map = defaultMap
		end
	end
		
	local name = mapheaderinfo[map].lvlttl
		
	if not (mapheaderinfo[map].levelflags & LF_NOZONE)
		name = $1.." Zone"
	end
		
	if mapheaderinfo[map].actnum
		name = $1.." "..mapheaderinfo[map].actnum
	end
		
	return name
end

local function getVoteString(p)
	if playerVotes[#p] == true
		return "You have voted \131YES\128."
	elseif playerVotes[#p] == false
		return "You have voted \133NO\128."
	else
		return "You have not voted yet."
	end
end

local function drawMapBadges(vid, map, x, y)
	local nextx = x
	
	if (mapheaderinfo[map].sugoiaward)
		vid.drawScaled(nextx*FRACUNIT, y*FRACUNIT, FRACUNIT/2, vid.cachePatch("MAPRIBN"..mapheaderinfo[currentVoteInfo.map].sugoiaward))
		nextx = $1-16
	end

	if (mapChecks[map])
		vid.drawScaled(nextx*FRACUNIT, y*FRACUNIT, FRACUNIT/2, vid.cachePatch("MAPSIGN"))
		nextx = $1-16
	end
end

local function drawVoting(vid, player)
	local p1 = players[0]
	local p2 = players[1]
	
	local bgcolor = 239
	
	local width = vid.width() / vid.dupx()
	local height = vid.height() / vid.dupy()
	local splitcoords = 0
	if (vid.renderer() == "opengl") -- HACK because ogl hud stuff just gets stretched anyway
		width = 320
		height = 200
	end
	if (player == p2)
		splitcoords = (height/2) - 6
	end
	
	local blapckscale = max(vid.width() / vid.dupx(), vid.height() / vid.dupy())
	vid.drawScaled(-1, -1, (blapckscale*FRACUNIT)+2, vid.cachePatch("BLAPCK"), V_SNAPTOTOP|V_SNAPTOLEFT|V_50TRANS)
		
	local controlstring = "[\130JUMP\128] Vote \131YES\128 - [\130SPIN\128] Vote \133NO\128"
	vid.drawFill(160 - (vid.stringWidth(controlstring, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE)/2) - 4, 180, vid.stringWidth(controlstring, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE) + 8, 16, V_SNAPTOBOTTOM + bgcolor)
	vid.drawString(160, 184, controlstring, V_SNAPTOBOTTOM|V_ALLOWLOWERCASE, "center")
		
	local startedname
	if (currentVoteInfo.player and currentVoteInfo.player.valid)
		startedname = currentVoteInfo.player.name
	elseif not startedname
		startedname = "Hilda"
	end
	
	local author = mapheaderinfo[currentVoteInfo.map].authorname or "STJr"
		
	if (multiplayer)
		vid.drawString(160, 8, "A vote was started by \130"..startedname, V_ALLOWLOWERCASE, "center")
		vid.drawString(160, 16, "for \130"..getMapName(currentVoteInfo.map).."\128", V_ALLOWLOWERCASE, "center")
		vid.drawString(160, 24, "by \130"..author.."\128.", V_ALLOWLOWERCASE, "center")
		
		vid.drawString(16, 144, "\130"..getVoteCount("yes").."\128 have voted \131YES\128.", V_ALLOWLOWERCASE, "left")
		vid.drawString(304, 144, "\130"..getVoteCount("no").."\128 have voted \133NO\128.", V_ALLOWLOWERCASE, "right")
	else
		vid.drawString(160, 8, "Are you sure you want to go", V_ALLOWLOWERCASE, "center")
		vid.drawString(160, 16, "to \130"..getMapName(currentVoteInfo.map).."\128", V_ALLOWLOWERCASE, "center")
		vid.drawString(160, 24, "by \130"..author.."\128?", V_ALLOWLOWERCASE, "center")
	end
		
	vid.drawFill(116, 44, 88, 56, bgcolor)

	if (mapheaderinfo[currentVoteInfo.map].hubimage)
		vid.drawScaled(120*FRACUNIT, 47*FRACUNIT, FRACUNIT/2, vid.cachePatch(mapheaderinfo[currentVoteInfo.map].hubimage))
	elseif (currentVoteInfo.map)
		vid.drawScaled(120*FRACUNIT, 47*FRACUNIT, FRACUNIT/2, vid.cachePatch(G_BuildMapName(currentVoteInfo.map).."P"))
	else
		vid.drawScaled(120*FRACUNIT, 47*FRACUNIT, FRACUNIT/2, vid.cachePatch(G_BuildMapName(defaultMap).."P"))
	end

	if (mapheaderinfo[currentVoteInfo.map].staticoverlay)
		vid.draw(120, 47, vid.cachePatch("MSTATIC"..((leveltime % 4)+1)), V_40TRANS)
	end

	drawMapBadges(vid, currentVoteInfo.map, 192, 89)
		
	vid.drawString(160, 128, getVoteString(player), V_ALLOWLOWERCASE, "center")
	
	if (cv_vote.value > 0)
		vid.drawString(160, 164, "Voting ends in "..currentVoteInfo.timer/TICRATE.." seconds", V_YELLOWMAP, "center")
	end
end

local function drawHud(vid, player)
	clientplayer = player
	clientrenderer = vid.renderer()
	
	if (modifiedgame) and not (multiplayer)
	and ((server and server.valid) and (clientplayer == server))
	and (leveltime >= 3*TICRATE) and not (didmodifiedprint)
		CONS_Printf(clientplayer, "\3\131Information:\128 This hub currently does not have a saving system. Feel free to beat the levels in any order, at any time.")
		didmodifiedprint = true
	end

	if (G_PlatformGametype())
		
		local p1 = players[0]
		local p2 = players[1]
		
		local bgcolor = 239
		
		local width = vid.width() / vid.dupx()
		local height = vid.height() / vid.dupy()
		local splitcoords = 0

		if (player == p2)
			splitcoords = (height/2) - 6
		end
		
		if (currentVoteInfo.voting and hubSpot)
			if (cv_vote.value == -1) return end
			if (splitscreen) and not (player == p1) return end
			drawVoting(vid, player)
		else
			if (gamemap == oldchub) then
				vid.drawString(0, 192, OLDC_SEASONS[CURRENT_SEASON] .. " " .. CURRENT_YEAR .. " OLDC", V_ALLOWLOWERCASE|V_50TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			end
			if not (modeattacking)	
				if (currentCecho.timer and currentCecho.text)
					vid.drawString(160, 176, currentCecho.text, currentCecho.flags, "center")
				end
			end
		end
	end
end

hud.add(drawHud, "game")
